%{/*                                              -*- C -*-  */
#include "parse.h"
extern int errors;

#define STEP()					\
 do {						\
   yylloc->first_line = yylloc->last_line;	\
   yylloc->first_column = yylloc->last_column;	\
 } while (0)

#define COL(Col)				\
  yylloc->last_column += (Col)

#define LINE(Line)				\
  do{						\
    yylloc->last_column = 1;			\
    yylloc->last_line += (Line);		\
 } while (0)

#define YY_USER_ACTION				\
  COL(yyleng);

%}
%option noyywrap nounput
%%
%{
  // Top most in yylex.
  STEP();
%}
"+"       return TOK_PLUS;
"-"       return TOK_MINUS;
"/"       return TOK_SLASH;
"*"       return TOK_STAR;
"("       return TOK_LPAR;
")"       return TOK_RPAR;
[0-9]+    yylval->ival = strtol(yytext, 0, 0);return TOK_INT;
"\n"      LINE(1); return TOK_EOL;
[ \t]+    STEP(); continue;
.         fprintf(stderr, "invalid character: `%s'\n", yytext); ++errors;
%%
